processing.data

## Class JSONObject

- Object
- - JSONObject

-     public class JSONObject
      extends Object

  A JSONObject is an unordered collection of name/value pairs. Its external form is a string wrapped in curly braces with colons between the names and values, and commas between the values and names. The internal form is an object having `get` and `opt` methods for accessing the values by name, and `put` methods for adding or replacing values by name. The values can be any of these types: `Boolean`, `JSONArray`, `JSONObject`, `Number`, `String`, or the `JSONObject.NULL` object. A JSONObject constructor can be used to convert an external form JSON text into an internal form whose values can be retrieved with the `get` and `opt` methods, or to convert values into a JSON text using the `put` and `toString` methods. A `get` method returns a value if one can be found, and throws an exception if one cannot be found. An `opt` method returns a default value instead of throwing an exception, and so is useful for obtaining optional values.

  The generic `get()` and `opt()` methods return an object, which you can cast or query for type. There are also typed `get` and `opt` methods that do type checking and type coercion for you. The opt methods differ from the get methods in that they do not throw. Instead, they return a specified value, such as null.

  The `put` methods add or replace values in an object. For example,

       myString = new JSONObject().put("JSON", "Hello, World!").toString();

  produces the string `{"JSON": "Hello, World"}`.

  The texts produced by the `toString` methods strictly conform to the JSON syntax rules. The constructors are more forgiving in the texts they will accept:

  - An extra `,` (comma) may appear just before the closing brace.
  - Strings may be quoted with `'` (single quote).
  - Strings do not need to be quoted at all if they do not begin with a quote or single quote, and if they do not contain leading or trailing spaces, and if they do not contain any of these characters: `{ } [ ] / \ : , = ; #` and if they do not look like numbers and if they are not the reserved words `true`, `false`, or `null`.
  - Keys can be followed by `=` or `=>` as well as by `:`.
  - Values can be followed by `;` (semicolon) as well as by `,` (comma).
  See Also:
    `JSONArray`, `PApplet.loadJSONObject(String)`, `PApplet.loadJSONArray(String)`, `PApplet.saveJSONObject(JSONObject, String)`, `PApplet.saveJSONArray(JSONArray, String)`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static Object` | `NULL` It is sometimes more convenient and less ambiguous to have a `NULL` object than to use Java's `null` value.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JSONObject()` Construct an empty JSONObject.
    `JSONObject(FloatDict dict)`
    `JSONObject(IntDict dict)`
    `JSONObject(Reader reader)`
    `JSONObject(StringDict dict)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `format(int indentFactor)` Make a prettyprinted JSON text of this JSONObject.
    `boolean` | `getBoolean(String key)` Get the boolean value associated with a key.
    `boolean` | `getBoolean(String key, boolean defaultValue)` Get an optional boolean associated with a key.
    `double` | `getDouble(String key)` Get the double value associated with a key.
    `double` | `getDouble(String key, double defaultValue)` Get an optional double associated with a key, or the defaultValue if there is no such key or if its value is not a number.
    `float` | `getFloat(String key)`
    `float` | `getFloat(String key, float defaultValue)`
    `int` | `getInt(String key)` Gets the int value associated with a key
    `int` | `getInt(String key, int defaultValue)` Get an optional int value associated with a key, or the default if there is no such key or if the value is not a number.
    `JSONArray` | `getJSONArray(String key)` Get the JSONArray value associated with a key.
    `JSONObject` | `getJSONObject(String key)` Get the JSONObject value associated with a key.
    `long` | `getLong(String key)` Get the long value associated with a key.
    `long` | `getLong(String key, long defaultValue)` Get an optional long value associated with a key, or the default if there is no such key or if the value is not a number.
    `String` | `getString(String key)` Gets the String associated with a key
    `String` | `getString(String key, String defaultValue)` Get an optional string associated with a key.
    `boolean` | `hasKey(String key)` Determine if the JSONObject contains a specific key.
    `boolean` | `isNull(String key)` Determine if the value associated with the key is null or if there is no value.
    `Iterator` | `keyIterator()` Get an enumeration of the keys of the JSONObject.
    `Set` | `keys()` Get a set of keys of the JSONObject.
    `static JSONObject` | `parse(String source)` Construct a JSONObject from a source JSON text string.
    `Object` | `remove(String key)` Remove a name and its value, if present.
    `boolean` | `save(File file, String options)`
    `JSONObject` | `setBoolean(String key, boolean value)` Put a key/boolean pair in the JSONObject.
    `JSONObject` | `setDouble(String key, double value)` Put a key/double pair in the JSONObject.
    `JSONObject` | `setFloat(String key, float value)`
    `JSONObject` | `setInt(String key, int value)` Put a key/int pair in the JSONObject.
    `JSONObject` | `setJSONArray(String key, JSONArray value)`
    `JSONObject` | `setJSONObject(String key, JSONObject value)`
    `JSONObject` | `setLong(String key, long value)` Put a key/long pair in the JSONObject.
    `JSONObject` | `setString(String key, String value)`
    `int` | `size()` Get the number of keys stored in the JSONObject.
    `String` | `toString()` Return the JSON data formatted with two spaces for indents.
    `boolean` | `write(PrintWriter output)`
    `boolean` | `write(PrintWriter output, String options)`

    - ### Methods inherited from class Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### NULL

          public static final Object NULL

      It is sometimes more convenient and less ambiguous to have a `NULL` object than to use Java's `null` value. `JSONObject.NULL.equals(null)` returns `true`. `JSONObject.NULL.toString()` returns `"null"`.

  - ### Constructor Detail

    - #### JSONObject

          public JSONObject()

      Construct an empty JSONObject.

    - #### JSONObject

          public JSONObject(Reader reader)

    - #### JSONObject

          public JSONObject(IntDict dict)

    - #### JSONObject

          public JSONObject(FloatDict dict)

    - #### JSONObject

          public JSONObject(StringDict dict)

  - ### Method Detail

    - #### parse

          public static JSONObject parse(String source)

      Construct a JSONObject from a source JSON text string. This is the most commonly used JSONObject constructor.
      Parameters:
        `source` - A string beginning with `{` (left brace) and ending with `}` (right brace).
      Throws:
        `JSONException` - If there is a syntax error in the source string or a duplicated key.

    - #### getString

          public String getString(String key)

      Gets the String associated with a key
      Parameters:
        `key` - a key string
      Returns:
        A string which is the value.
      Throws:
        `JSONException` - if there is no string value for the key.
      See Also:
        `getInt(String)`, `getFloat(String)`, `getBoolean(String)`

    - #### getString

          public String getString(String key,
                                  String defaultValue)

      Get an optional string associated with a key. It returns the defaultValue if there is no such key.
      Parameters:
        `key` - A key string.
        `defaultValue` - The default.
      Returns:
        A string which is the value.

    - #### getInt

          public int getInt(String key)

      Gets the int value associated with a key
      Parameters:
        `key` - a key string
      Returns:
        The integer value.
      Throws:
        `JSONException` - if the key is not found or if the value cannot be converted to an integer.
      See Also:
        `getFloat(String)`, `getString(String)`, `getBoolean(String)`

    - #### getInt

          public int getInt(String key,
                            int defaultValue)

      Get an optional int value associated with a key, or the default if there is no such key or if the value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
      Parameters:
        `key` - A key string.
        `defaultValue` - The default.
      Returns:
        An object which is the value.

    - #### getLong

          public long getLong(String key)

      Get the long value associated with a key.
      Parameters:
        `key` - A key string.
      Returns:
        The long value.
      Throws:
        `JSONException` - if the key is not found or if the value cannot be converted to a long.

    - #### getLong

          public long getLong(String key,
                              long defaultValue)

      Get an optional long value associated with a key, or the default if there is no such key or if the value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
      Parameters:
        `key` - A key string.
        `defaultValue` - The default.
      Returns:
        An object which is the value.

    - #### getFloat

          public float getFloat(String key)

      Parameters:
        `key` - a key string
      See Also:
        `getInt(String)`, `getString(String)`, `getBoolean(String)`

    - #### getFloat

          public float getFloat(String key,
                                float defaultValue)

    - #### getDouble

          public double getDouble(String key)

      Get the double value associated with a key.
      Parameters:
        `key` - A key string.
      Returns:
        The numeric value.
      Throws:
        `JSONException` - if the key is not found or if the value is not a Number object and cannot be converted to a number.

    - #### getDouble

          public double getDouble(String key,
                                  double defaultValue)

      Get an optional double associated with a key, or the defaultValue if there is no such key or if its value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.
      Parameters:
        `key` - A key string.
        `defaultValue` - The default.
      Returns:
        An object which is the value.

    - #### getBoolean

          public boolean getBoolean(String key)

      Get the boolean value associated with a key.
      Parameters:
        `key` - a key string
      Returns:
        The truth.
      Throws:
        `JSONException` - if the value is not a Boolean or the String "true" or "false".
      See Also:
        `getInt(String)`, `getFloat(String)`, `getString(String)`

    - #### getBoolean

          public boolean getBoolean(String key,
                                    boolean defaultValue)

      Get an optional boolean associated with a key. It returns the defaultValue if there is no such key, or if it is not a Boolean or the String "true" or "false" (case insensitive).
      Parameters:
        `key` - A key string.
        `defaultValue` - The default.
      Returns:
        The truth.

    - #### getJSONArray

          public JSONArray getJSONArray(String key)

      Get the JSONArray value associated with a key.
      Parameters:
        `key` - a key string
      Returns:
        A JSONArray which is the value.
      Throws:
        `JSONException` - if the key is not found or if the value is not a JSONArray.
      See Also:
        `getJSONObject(String)`, `setJSONObject(String, JSONObject)`, `setJSONArray(String, JSONArray)`

    - #### getJSONObject

          public JSONObject getJSONObject(String key)

      Get the JSONObject value associated with a key.
      Parameters:
        `key` - a key string
      Returns:
        A JSONObject which is the value.
      Throws:
        `JSONException` - if the key is not found or if the value is not a JSONObject.
      See Also:
        `getJSONArray(String)`, `setJSONObject(String, JSONObject)`, `setJSONArray(String, JSONArray)`

    - #### hasKey

          public boolean hasKey(String key)

      Determine if the JSONObject contains a specific key.
      Parameters:
        `key` - A key string.
      Returns:
        true if the key exists in the JSONObject.

    - #### isNull

          public boolean isNull(String key)

      Determine if the value associated with the key is null or if there is no value.
      Parameters:
        `key` - A key string.
      Returns:
        true if there is no value associated with the key or if the value is the JSONObject.NULL object.

    - #### keyIterator

          public Iterator keyIterator()

      Get an enumeration of the keys of the JSONObject.
      Returns:
        An iterator of the keys.

    - #### keys

          public Set keys()

      Get a set of keys of the JSONObject.
      Returns:
        A keySet.

    - #### size

          public int size()

      Get the number of keys stored in the JSONObject.
      Returns:
        The number of keys in the JSONObject.

    - #### setString

          public JSONObject setString(String key,
                                      String value)

      Parameters:
        `key` - a key string
        `value` - the value to assign
      See Also:
        `setInt(String, int)`, `setFloat(String, float)`, `setBoolean(String, boolean)`

    - #### setInt

          public JSONObject setInt(String key,
                                   int value)

      Put a key/int pair in the JSONObject.
      Parameters:
        `key` - a key string
        `value` - the value to assign
      Returns:
        this.
      Throws:
        `JSONException` - If the key is null.
      See Also:
        `setFloat(String, float)`, `setString(String, String)`, `setBoolean(String, boolean)`

    - #### setLong

          public JSONObject setLong(String key,
                                    long value)

      Put a key/long pair in the JSONObject.
      Parameters:
        `key` - A key string.
        `value` - A long which is the value.
      Returns:
        this.
      Throws:
        `JSONException` - If the key is null.

    - #### setFloat

          public JSONObject setFloat(String key,
                                     float value)

      Parameters:
        `key` - a key string
        `value` - the value to assign
      See Also:
        `setInt(String, int)`, `setString(String, String)`, `setBoolean(String, boolean)`

    - #### setDouble

          public JSONObject setDouble(String key,
                                      double value)

      Put a key/double pair in the JSONObject.
      Parameters:
        `key` - A key string.
        `value` - A double which is the value.
      Returns:
        this.
      Throws:
        `JSONException` - If the key is null or if the number is invalid.

    - #### setBoolean

          public JSONObject setBoolean(String key,
                                       boolean value)

      Put a key/boolean pair in the JSONObject.
      Parameters:
        `key` - a key string
        `value` - the value to assign
      Returns:
        this.
      Throws:
        `JSONException` - If the key is null.
      See Also:
        `setInt(String, int)`, `setFloat(String, float)`, `setString(String, String)`

    - #### setJSONObject

          public JSONObject setJSONObject(String key,
                                          JSONObject value)

      Parameters:
        `key` - a key string
        `value` - value to assign
      See Also:
        `setJSONArray(String, JSONArray)`, `getJSONObject(String)`, `getJSONArray(String)`

    - #### setJSONArray

          public JSONObject setJSONArray(String key,
                                         JSONArray value)

      Parameters:
        `key` - a key string
        `value` - value to assign
      See Also:
        `setJSONObject(String, JSONObject)`, `getJSONObject(String)`, `getJSONArray(String)`

    - #### remove

          public Object remove(String key)

      Remove a name and its value, if present.
      Parameters:
        `key` - The name to be removed.
      Returns:
        The value that was associated with the name, or null if there was no value.

    - #### save

          public boolean save(File file,
                              String options)

    - #### write

          public boolean write(PrintWriter output)

    - #### write

          public boolean write(PrintWriter output,
                               String options)

    - #### toString

          public String toString()

      Return the JSON data formatted with two spaces for indents. Chosen to do this since it's the most common case (e.g. with println()). Same as format(2). Use the format() function for more options.
      Overrides:
        `toString` in class `Object`

    - #### format

          public String format(int indentFactor)

      Make a prettyprinted JSON text of this JSONObject.

      Warning: This method assumes that the data structure is acyclical.

      Parameters:
        `indentFactor` - The number of spaces to add to each level of indentation.
      Returns:
        a printable, displayable, portable, transmittable representation of the object, beginning with `{` (left brace) and ending with `}` (right brace).
      Throws:
        `JSONException` - If the object contains an invalid number.